const _S           = String;


const raw          = _S.raw;
const cd2ch        = (c)=>_S.fromCodePoint(c); 
const ch2cd        = (s)=>s.codePointAt(0);

const ascii_cd2ch  = (c)=>_S.fromCharCode(c);
const ascii_ch2cd  = (s)=>s.charCodeAt(0);

const is_high_surrogate  =(n)=>(n>>8 & 0b1111_1100) === 0b1101_1000;
const is_low_surrogate   =(n)=>(n>>8 & 0b1111_1100) === 0b1101_1100;
const is_not_surrogate   =(n)=>(!is_high_surrogate(n)) && (!is_low_surrogate(n));


const surrogate_to_code     = (n16_0,n16_1)=> (
     ((n16_0 & 0x03ff) << 10) +
     ((n16_1 & 0x03ff)) +
     0x10000
);


const chlen = (s) => {
    let ei  = s.length;
    let i   = 0;
    let cnt = 0;
    let cd;
    while(i<ei) {
        cd = ascii_ch2cd(s[i]);
        ++cnt;
        if(is_high_surrogate(cd)) {
            ++i;
            ++i;
        } else {
            ++i;
        }
    }
    return(cnt)
}

const cdat   = (s,chidx) => {
    let ei   = s.length;
    let i    = 0;
    let idx  = 0;
    let code = -1;
    let cd;
    while(i<ei) {
        cd = ascii_ch2cd(s[i]);
        if(is_high_surrogate(cd)) {
            code = surrogate_to_code(cd,ascii_ch2cd(s[i+1]));
            if(idx === chidx) {
                return(code)
            } else {
                ++i;
                ++i;
                ++idx;
            }
        } else {
            code = cd;
            if(idx === chidx) {
                return(code)
            } else {
                ++i;
                ++idx;
            }
        }
    }
}

const chat = (s,chidx) => cd2ch(cdat(s,chidx));


module.exports = {
   raw, 
   ch2cd,cd2ch, 
   ascii_cd2ch,ascii_ch2cd, 
   is_high_surrogate,
   is_low_surrogate,
   is_not_surrogate,
   surrogate_to_code,
   chlen,
   cdat, 
   chat, 
}

